library IEEE;
library work;

use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use STD.TEXTIO.ALL;
use work.multiboot_pkg.ALL;

package multiboot_pkg_tb is

   constant c_WB_CLK_PERIOD  : TIME := 50 ns;
   file file_handler         : TEXT;
   constant c_LOG_PATH       : STRING := "../test/log/multiboot_top_tb.log";
   constant sep              : CHARACTER := ht;

  -- Component Declaration
   component multiboot_top is
      generic(g_MBA_addr : UNSIGNED (23 downto 0) := UNSIGNED(c_MBA_map_addr);
              g_GBA_addr : UNSIGNED (23 downto 0) := UNSIGNED(c_GBA_map_addr);
              --! Read operation code for a m25p32 memory
              g_READ_SPI_OPCODE : STD_LOGIC_VECTOR(7 downto 0) := X"03");
      port(
             wb_rst_i   : in   STD_LOGIC;
             wb_clk     : in   STD_LOGIC;
             wb_we_i    : in   STD_LOGIC;
             wb_stb_i   : in   STD_LOGIC;
             wb_cyc_i   : in   STD_LOGIC;
             wb_sel_i   : in   STD_LOGIC_VECTOR (3  downto 0);
             wb_data_i  : in   STD_LOGIC_VECTOR (31 downto 0);
             wb_data_o  : out  STD_LOGIC_VECTOR (31 downto 0);
             wb_addr_i  : in   STD_LOGIC_VECTOR (3  downto 0);
             wb_ack_o   : out  STD_LOGIC;
             wb_rty_o   : out  STD_LOGIC;
             wb_err_o   : out  STD_LOGIC);
   end component;

end multiboot_pkg_tb;

package body multiboot_pkg_tb is
end multiboot_pkg_tb;
